// Compiled by ClojureScript 1.9.562 {}
goog.provide('octet.spec.basic');
goog.require('cljs.core');
goog.require('octet.buffer');
goog.require('octet.spec');
octet.spec.basic.primitive_spec = (function octet$spec$basic$primitive_spec(size,readfn,writefn){
if(typeof octet.spec.basic.t_octet$spec$basic34334 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IFn}
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34334 = (function (size,readfn,writefn,meta34335){
this.size = size;
this.readfn = readfn;
this.writefn = writefn;
this.meta34335 = meta34335;
this.cljs$lang$protocol_mask$partition0$ = 393217;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34334.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34336,meta34335__$1){
var self__ = this;
var _34336__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34334(self__.size,self__.readfn,self__.writefn,meta34335__$1));
});

octet.spec.basic.t_octet$spec$basic34334.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34336){
var self__ = this;
var _34336__$1 = this;
return self__.meta34335;
});

octet.spec.basic.t_octet$spec$basic34334.prototype.call = (function (self__){
var self__ = this;
var self____$1 = this;
var s = self____$1;
return s;
});

octet.spec.basic.t_octet$spec$basic34334.prototype.apply = (function (self__,args34337){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args34337)));
});

octet.spec.basic.t_octet$spec$basic34334.prototype.cljs$core$IFn$_invoke$arity$0 = (function (){
var self__ = this;
var s = this;
return s;
});

octet.spec.basic.t_octet$spec$basic34334.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34334.prototype.octet$spec$ISpecSize$size$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.size;
});

octet.spec.basic.t_octet$spec$basic34334.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34334.prototype.octet$spec$ISpec$read$arity$3 = (function (_,buff,pos){
var self__ = this;
var ___$1 = this;
var readed = self__.readfn.call(null,buff,pos);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.size,readed], null);
});

octet.spec.basic.t_octet$spec$basic34334.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
var G__34338_34339 = value;
if((G__34338_34339 == null)){
} else {
self__.writefn.call(null,buff,pos,G__34338_34339);
}

return self__.size;
});

octet.spec.basic.t_octet$spec$basic34334.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.Symbol(null,"readfn","readfn",1394986672,null),new cljs.core.Symbol(null,"writefn","writefn",1052701163,null),new cljs.core.Symbol(null,"meta34335","meta34335",1072514632,null)], null);
});

octet.spec.basic.t_octet$spec$basic34334.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34334.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34334";

octet.spec.basic.t_octet$spec$basic34334.cljs$lang$ctorPrWriter = (function (this__23995__auto__,writer__23996__auto__,opt__23997__auto__){
return cljs.core._write.call(null,writer__23996__auto__,"octet.spec.basic/t_octet$spec$basic34334");
});

octet.spec.basic.__GT_t_octet$spec$basic34334 = (function octet$spec$basic$primitive_spec_$___GT_t_octet$spec$basic34334(size__$1,readfn__$1,writefn__$1,meta34335){
return (new octet.spec.basic.t_octet$spec$basic34334(size__$1,readfn__$1,writefn__$1,meta34335));
});

}

return (new octet.spec.basic.t_octet$spec$basic34334(size,readfn,writefn,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Boolean type spec.
 */
octet.spec.basic.bool = (function (){
if(typeof octet.spec.basic.t_octet$spec$basic34340 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IFn}
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34340 = (function (meta34341){
this.meta34341 = meta34341;
this.cljs$lang$protocol_mask$partition0$ = 393217;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34340.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34342,meta34341__$1){
var self__ = this;
var _34342__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34340(meta34341__$1));
});

octet.spec.basic.t_octet$spec$basic34340.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34342){
var self__ = this;
var _34342__$1 = this;
return self__.meta34341;
});

octet.spec.basic.t_octet$spec$basic34340.prototype.call = (function (self__){
var self__ = this;
var self____$1 = this;
var s = self____$1;
return s;
});

octet.spec.basic.t_octet$spec$basic34340.prototype.apply = (function (self__,args34343){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args34343)));
});

octet.spec.basic.t_octet$spec$basic34340.prototype.cljs$core$IFn$_invoke$arity$0 = (function (){
var self__ = this;
var s = this;
return s;
});

octet.spec.basic.t_octet$spec$basic34340.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34340.prototype.octet$spec$ISpecSize$size$arity$1 = (function (__SHARP_){
var self__ = this;
var __SHARP___$1 = this;
return (1);
});

octet.spec.basic.t_octet$spec$basic34340.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34340.prototype.octet$spec$ISpec$read$arity$3 = (function (__SHARP_,buff,pos){
var self__ = this;
var __SHARP___$1 = this;
var readed = octet.buffer.read_byte.call(null,buff,pos);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(1),(function (){var pred__34344 = cljs.core._EQ_;
var expr__34345 = readed;
if(cljs.core.truth_(pred__34344.call(null,(0),expr__34345))){
return false;
} else {
if(cljs.core.truth_(pred__34344.call(null,(1),expr__34345))){
return true;
} else {
return null;
}
}
})()], null);
});

octet.spec.basic.t_octet$spec$basic34340.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
var value__$1 = (function (){var pred__34347 = cljs.core._EQ_;
var expr__34348 = value;
if(cljs.core.truth_(pred__34347.call(null,true,expr__34348))){
return (1);
} else {
if(cljs.core.truth_(pred__34347.call(null,false,expr__34348))){
return (0);
} else {
return (-1);
}
}
})();
octet.buffer.write_byte.call(null,buff,pos,value__$1);

return (1);
});

octet.spec.basic.t_octet$spec$basic34340.getBasis = (function (){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"meta34341","meta34341",1249706960,null)], null);
});

octet.spec.basic.t_octet$spec$basic34340.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34340.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34340";

octet.spec.basic.t_octet$spec$basic34340.cljs$lang$ctorPrWriter = (function (this__23995__auto__,writer__23996__auto__,opt__23997__auto__){
return cljs.core._write.call(null,writer__23996__auto__,"octet.spec.basic/t_octet$spec$basic34340");
});

octet.spec.basic.__GT_t_octet$spec$basic34340 = (function octet$spec$basic$__GT_t_octet$spec$basic34340(meta34341){
return (new octet.spec.basic.t_octet$spec$basic34340(meta34341));
});

}

return (new octet.spec.basic.t_octet$spec$basic34340(cljs.core.PersistentArrayMap.EMPTY));
})()
;
/**
 * Byte type spec.
 */
octet.spec.basic.byte$ = octet.spec.basic.primitive_spec.call(null,(1),octet.buffer.read_byte,octet.buffer.write_byte);
/**
 * Short type spec.
 */
octet.spec.basic.int16 = octet.spec.basic.primitive_spec.call(null,(2),octet.buffer.read_short,octet.buffer.write_short);
/**
 * Integer type spec.
 */
octet.spec.basic.int32 = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_int,octet.buffer.write_int);
/**
 * Long type spec.
 */
octet.spec.basic.int64 = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_long,octet.buffer.write_long);
/**
 * Float type spec
 */
octet.spec.basic.float$ = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_float,octet.buffer.write_float);
/**
 * Double type spec.
 */
octet.spec.basic.double$ = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_double,octet.buffer.write_double);
/**
 * Fixed size byte array type spec constructor.
 */
octet.spec.basic.bytes = (function octet$spec$basic$bytes(size){
if(typeof octet.spec.basic.t_octet$spec$basic34353 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34353 = (function (size,meta34354){
this.size = size;
this.meta34354 = meta34354;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34353.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34355,meta34354__$1){
var self__ = this;
var _34355__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34353(self__.size,meta34354__$1));
});

octet.spec.basic.t_octet$spec$basic34353.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34355){
var self__ = this;
var _34355__$1 = this;
return self__.meta34354;
});

octet.spec.basic.t_octet$spec$basic34353.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34353.prototype.octet$spec$ISpecSize$size$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.size;
});

octet.spec.basic.t_octet$spec$basic34353.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34353.prototype.octet$spec$ISpec$read$arity$3 = (function (_,buff,pos){
var self__ = this;
var ___$1 = this;
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.size,octet.buffer.read_bytes.call(null,buff,pos,self__.size)], null);
});

octet.spec.basic.t_octet$spec$basic34353.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
octet.buffer.write_bytes.call(null,buff,pos,self__.size,value);

return self__.size;
});

octet.spec.basic.t_octet$spec$basic34353.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol(null,"long","long",1469079434,null)], null)),new cljs.core.Symbol(null,"meta34354","meta34354",373622051,null)], null);
});

octet.spec.basic.t_octet$spec$basic34353.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34353.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34353";

octet.spec.basic.t_octet$spec$basic34353.cljs$lang$ctorPrWriter = (function (this__23995__auto__,writer__23996__auto__,opt__23997__auto__){
return cljs.core._write.call(null,writer__23996__auto__,"octet.spec.basic/t_octet$spec$basic34353");
});

octet.spec.basic.__GT_t_octet$spec$basic34353 = (function octet$spec$basic$bytes_$___GT_t_octet$spec$basic34353(size__$1,meta34354){
return (new octet.spec.basic.t_octet$spec$basic34353(size__$1,meta34354));
});

}

return (new octet.spec.basic.t_octet$spec$basic34353(size,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Unsinged int16 type spec.
 */
octet.spec.basic.uint16 = octet.spec.basic.primitive_spec.call(null,(2),octet.buffer.read_ushort,octet.buffer.write_ushort);
/**
 * Unsinged int32 type spec.
 */
octet.spec.basic.uint32 = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_uint,octet.buffer.write_uint);
/**
 * Unsinged byte type spec.
 */
octet.spec.basic.ubyte = octet.spec.basic.primitive_spec.call(null,(1),octet.buffer.read_ubyte,octet.buffer.write_ubyte);
/**
 * Unsinged int64 type spec.
 */
octet.spec.basic.uint64 = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_ulong,octet.buffer.write_ulong);
